/**
 *  .werkkzeug 1.201 structures.
 *  (c) 2010-2011, Sauron.
 */

#ifndef __WZINFO_H
#define __WZINFO_H

#define WZ_MAX_ANIMS    20
#define WZ_MAX_LINKS    8
#define WZ_NAME_SIZE    32

#define PACKED __attribute__((__packed__))

struct wzproject {
    unsigned long magic;
    unsigned long version;
    unsigned long nblocks;
    unsigned long npages;
    struct block *blocks;
    char **pages;
} PACKED;

struct anim {
    unsigned long flags;
    unsigned long channel;
    unsigned long mask;
    unsigned long components;
    unsigned long amplify;
    unsigned long para[4];
} PACKED;

struct block {
    unsigned char xpos;
    unsigned char ypos;
    unsigned char page;
    unsigned char width;
    unsigned char nlinks;
    unsigned char nanims;
    unsigned char dwords;
    unsigned char flags;
    unsigned long cid;
    unsigned long links[WZ_MAX_LINKS];
    struct anim anims[WZ_MAX_ANIMS];
    unsigned long para[64];
    char *name;
    char *blob;
    unsigned long blob_size;
    unsigned int offset;    // debug
} PACKED;

// Werkkzeug file parse errors
#define WZ_SUCCESS          0
#define WZ_MEMORY           -1   // Out of memory
#define WZ_READFILE         -2   // Cannot read file
#define WZ_OPENFILE         -3   // File cannot be opened
#define WZ_EOF              -4   // Unexpected EOF
#define WZ_TOO_MANY_ANIMS   -5   // Too many animated parameters (during load)
#define WZ_TOO_MANY_LINKS   -6   // Too many link references (during load)
#define WZ_UNKNOWN_FORMAT   -12  // Unknown file format
#define WZ_UNKNOWN          -13  // Unknown error (it cannot happens)

// Block flag constants
#define WZ_HAS_NAME 1
#define WZ_HAS_BLOB 2

#endif /* __WZINFO_H */
